#include <iostream> 
#include <vector>
#include <queue>

using namespace std;

struct node{
  int num_trade;
  string my_goods;

};

// returns the number of extra items if goal is met, -1 otherwise
int Check_Done(string mine, string goal){
  for(int i = 0; i < goal.size(); i++){
    char cur_item = goal[i];
    int item_pos = mine.find(cur_item);
    if(item_pos == string::npos)
      return -1;
    else 
      mine.erase(item_pos,1);
  }
  return mine.size();
}
    

string Complete_Trade(string source, string dest, string my_stuff){
  
  for(int i = 0; i < source.size(); i++){
    char cur_item = source[i];
    int item_pos = my_stuff.find(cur_item);
    if(item_pos == string::npos)
      return "";
    else
      my_stuff.erase(item_pos, 1);
  }
  return my_stuff + dest;
}

void Swap(string &x, string& y){
  string temp = x;
  x = y;
  y = temp;
}

bool Make_Trades(string starting, string goal, const vector<string>& trades, int& trades_made, int& extra){
  queue<node> BFS_List;
  node start;
  start.num_trade = 0;
  start.my_goods=starting;
  BFS_List.push(start);
  trades_made = 8;
  extra = 1000000;
  bool keep_going = true;
  while(BFS_List.size() > 0){
    node cur = BFS_List.front();
    BFS_List.pop();
    // cout << cur.num_trade << endl;
    if(cur.num_trade <= trades_made){ // don't bother looking if it's too many trades
      int extra_items = Check_Done(cur.my_goods, goal);
      if(cur.num_trade == 7 && extra_items >= 0){ // last chance
	if(cur.num_trade < trades_made ||
	   cur.num_trade == trades_made && extra_items < extra){
	  trades_made = cur.num_trade;
	  extra = extra_items;
	}
      }
      else{ // not 10 trades yet
	if(extra_items >= 0){ // we have a solution
	  if(cur.num_trade < trades_made ||
	     cur.num_trade == trades_made && extra_items < extra){
	    trades_made = cur.num_trade;
	    extra = extra_items;
	  }
	}
	else{ // let's try making another trade

	  for(int i = 0; i < trades.size(); i++){
	    // try first->second
	    int divider = trades[i].find('=');
	    string source = trades[i].substr(0,divider);
	    string dest = trades[i].substr(divider+1);
	    string my_stuff = cur.my_goods;
	    string result = Complete_Trade(source, dest, my_stuff);
	    if(result != ""){ // then trade worked
	      node next_node;
	      next_node.num_trade = cur.num_trade+1;
	      next_node.my_goods = result;
	      BFS_List.push(next_node);
	    }
	    // try second->first
	    Swap(source, dest);
	    my_stuff = cur.my_goods;
	    result = Complete_Trade(source, dest, my_stuff);
	    if(result != ""){ // then trade worked
	      node next_node;
	      next_node.num_trade = cur.num_trade+1;
	      next_node.my_goods = result;
	      BFS_List.push(next_node);
	    }
	  }
	}
      }  // end case where we have <10 trades
    }
    
  }
  if(trades_made <= 7)
    return true;
  else
    return false;
}

int main(){
  int cur_case = 1;
  int n;
  cin >> n;
  while(n > 0){
    int m;
    cin >> m;
    vector<string> trades(m);
    for(int i = 0; i < m; i++)
      cin >> trades[i];
    string starting;
    cin >> starting;
      string goal;
    cin >> goal;
  
  

    int num_trades;
    int extra;
    if(Make_Trades(starting, goal, trades, num_trades, extra)){
      cout << "Case " << cur_case << ": Trading complete in " << num_trades << " trades, with " << extra  <<" extra." << endl;
    }
    
    else{
      cout << "Case " << cur_case << ": No sequence of 7 or less trades exists." << endl;
    }
    cur_case++;
    cin >> n;
  }
  return 0;
}
