#include <iostream>
#include <vector>

using namespace std;
void Print_Grid(vector<vector<char> >& Grid){
  for(int i = 0; i < Grid.size(); i++){
    for(int j = 0; j < Grid[i].size(); j++){
      cout << Grid[i][j];
    }
    cout << endl;
  }
  cout << endl;
}

void Shoot(vector<vector<char> >& Grid, int dan_r, int dan_c){
  // look north

  int north_row = -1;

  for(int cur_r = dan_r; cur_r >= 0; cur_r--) {
    if(Grid[cur_r][dan_c] == 'A'){
      north_row = cur_r;
      cur_r = -1;
    }
    else if(Grid[cur_r][dan_c] == 'X'){
      cur_r = -1;
    }
  }

  // look south
  int south_row = Grid.size();
  for(int cur_r = dan_r; cur_r < Grid.size(); cur_r++){
    if(Grid[cur_r][dan_c] == 'A'){
      south_row = cur_r;
      cur_r = Grid.size();
    }
    else if(Grid[cur_r][dan_c] == 'X'){
      cur_r = Grid.size();
    }
  }

  // look east
  int east_col = -1;
  for(int cur_c = dan_c; cur_c >= 0; cur_c--){
     if(Grid[dan_r][cur_c] == 'A'){
      east_col = cur_c;
      cur_c = -1;
    }
     else if(Grid[dan_r][cur_c] == 'X'){
      cur_c = -1;
    }
  }

  // look west
  int west_col = Grid[0].size();
  for(int cur_c = dan_c; cur_c < Grid[0].size(); cur_c++){
    if(Grid[dan_r][cur_c] == 'A'){
      west_col = cur_c;
      cur_c = Grid[0].size();
    }
    else if(Grid[dan_r][cur_c] == 'X'){
      cur_c = Grid[0].size();
    }
  }
  int best_distance = max(Grid.size()+1, Grid[0].size() +1);
  int shoot_r = -1;
  int shoot_c = -1;

  if(north_row != -1){ // found one north
    best_distance = dan_r - north_row;
    shoot_r = north_row;
    shoot_c = dan_c;
  }

  if(south_row != Grid.size()){ // found one south
    int south_distance = south_row - dan_r;
    if(south_distance < best_distance){
      best_distance = south_distance;
      shoot_r = south_row;
      shoot_c = dan_c;
    }
  }

  if(east_col != -1){ // found one east
    int east_distance = dan_c - east_col;
    if(east_distance < best_distance){
      best_distance = east_distance;
      shoot_r = dan_r;
      shoot_c = east_col;
    }
  }

  if(west_col != Grid[0].size()){ // found one west
    int west_distance = west_col - dan_c;
    if(west_distance < best_distance){
      best_distance = west_distance;
      shoot_r = dan_r;
      shoot_c = west_col;
    }
  }

  if(shoot_r != -1 && shoot_c != -1)
    Grid[shoot_r][shoot_c] = '-';
}


void Expand(vector<vector<char> >& Grid){

  // to deal with the issue of making sure we don't expand one amoeba 2 spaces in one step, I'll 
  // build a temporary grid with all of the expansions (you expand if you're empty but have an A in an adjacent 
  // space on the original grid
  vector<vector<char> > Temp_Grid(Grid.size());
  for(int i = 0; i < Grid.size(); i++){
    Temp_Grid[i].resize(Grid[i].size());
    for(int j = 0; j < Grid[i].size(); j++){
      Temp_Grid[i][j] = Grid[i][j]; // anything but empty space
      if(Temp_Grid[i][j] == '-' || Temp_Grid[i][j] == 'D'){
	if((i > 0 && Grid[i-1][j] == 'A') ||
	   (i < Grid.size()-1 && Grid[i+1][j] == 'A') ||
	   (j > 0 && Grid[i][j-1] == 'A') ||
	   (j < Grid[0].size()-1 && Grid[i][j+1] == 'A'))
	  Temp_Grid[i][j] = 'A';
      }
    }
  }
  // copy it all back
  for(int i = 0; i < Grid.size(); i++)
    for(int j = 0; j < Grid[i].size(); j++)
      Grid[i][j] = Temp_Grid[i][j];
}

	
int main(){
  int cur_planet = 1;
  int r,c;
  cin >> r >> c;
  while( r > 0){
    int dan_r;
    int dan_c;
    vector<vector<char> > Grid(r);
    for(int i = 0; i < r; i++){
      Grid[i].resize(c);
      for(int j = 0; j < c; j++){
	cin >> Grid[i][j];
	if(Grid[i][j] == 'D'){
	  dan_r = i;
	  dan_c = j;
	}
      }
    }
    
    
    int cur_time = 1;
    bool keep_going = true;
    while(keep_going){
      
      Shoot(Grid, dan_r, dan_c);
      //   Print_Grid(Grid);
      cur_time++;
      Expand(Grid);
      //     Print_Grid(Grid);
      if(Grid[dan_r][dan_c] == 'A')
	keep_going = false;
      else{
	cur_time++;
	if(cur_time > 2*r*c)
	  keep_going = false;
      }
    }

    if(Grid[dan_r][dan_c] == 'A'){
      cout << "Planet " << cur_planet << ": Dan will be eaten in " << cur_time << " minutes!" << endl;
    }
    else
      cout << "Planet " << cur_planet << ": Dan can hold out indefinitely!" << endl;
    cur_planet++;
    cin >> r >> c;
  }
  return 0;
}
      
